package nl.kallestruik.dtweaks.tweaks.croptweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Material
import org.bukkit.Particle
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.block.Action
import org.bukkit.event.player.PlayerInteractEvent
import org.bukkit.inventory.EquipmentSlot
import org.bukkit.plugin.java.JavaPlugin

class SugarcaneBonemealing(
    private val plugin: JavaPlugin
): ITweak, Listener {
    override fun getIdentifier(): String = "SugarcaneBonemealing"
    override fun getCategories(): List<String> = listOf("crops", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onRightClickBlock(event: PlayerInteractEvent) {
        val player = event.player

        if (event.hand != EquipmentSlot.HAND) return
        if (event.action != Action.RIGHT_CLICK_BLOCK) return
        if (event.clickedBlock == null) return
        if (event.clickedBlock!!.type != Material.SUGAR_CANE) return
        val itemInHand = player.inventory.itemInMainHand
        if (itemInHand.type != Material.BONE_MEAL) return

        val world = event.clickedBlock!!.world
        val origin = event.clickedBlock!!.location

        for (i in 0..3) {
            val newPos = origin.clone().add(0.0, i.toDouble(), 0.0)
            val newBlock = world.getBlockAt(newPos)
            if (newBlock.type != Material.AIR) continue
            if (newBlock.getRelative(0, -1, 0).type != Material.SUGAR_CANE) continue
            newBlock.type = Material.SUGAR_CANE
            world.spawnParticle(Particle.VILLAGER_HAPPY, newPos, 5, 0.5, 0.5, 0.5)
            itemInHand.amount = itemInHand.amount - 1
            break
        }
    }
}