package nl.kallestruik.dtweaks.tweaks.mobtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.entity.EntityType
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityChangeBlockEvent
import org.bukkit.plugin.java.JavaPlugin

class NoEndermanGrief(
    private val plugin: JavaPlugin
): ITweak, Listener {
    override fun getIdentifier(): String = "NoEndermanGrief"
    override fun getCategories(): List<String> = listOf("mobs", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onEndermanPickupBlock(event: EntityChangeBlockEvent) {
        if (event.entityType != EntityType.ENDERMAN) return
        event.isCancelled = true
    }
}